import java.io.IOException;
import java.nio.file.*;
import java.util.*;

public class ROT13  {
    private String cryptKey;
    private String alphabet = "abcdefghijklmnopqrstuvwxyz";
    private String sonnet = "/Users/jaredn/Labs/week5/ZCW-SimpleCrypt0/sonnet18.txt";
    private String cryptSonnet = "/Users/jaredn/Labs/week5/ZCW-SimpleCrypt0/sonnet18.enc";


    ROT13(Character cs, Character cf) {
        cryptKey = rotate(alphabet, alphabet.charAt(Math.abs((int)cs - (int)cf)));
    }

    ROT13(){ cryptKey = rotate(alphabet, 'n'); }

    @SuppressWarnings("Duplicates")
    public String encrypt(String text) {
        StringBuilder result = new StringBuilder();

        for(Character c : text.toCharArray()) {
            if (Character.isLetter(c)) {
                if (Character.isUpperCase(c)) {
                    result.append(Character.toUpperCase(cryptKey.charAt(alphabet.indexOf(Character.toLowerCase(c)))));
                }
                else result.append(cryptKey.charAt(alphabet.indexOf(c)));
            }
            else result.append(c);
        }
        return result.toString();
    }

    @SuppressWarnings("Duplicates")
    public String decrypt(String text) {
        StringBuilder result = new StringBuilder();

        for(Character c : text.toCharArray()) {
            if (Character.isLetter(c)) {
                if (Character.isUpperCase(c)) {
                    result.append(Character.toUpperCase(alphabet.charAt(cryptKey.indexOf(Character.toLowerCase(c)))));
                }
                else result.append(alphabet.charAt(cryptKey.indexOf(c)));
            }
            else result.append(c);
        }
        return result.toString();
    }

    public static String rotate(String s, Character c) {
        return s.substring(s.indexOf(c)) + s.substring(0, s.indexOf(c));
    }

    public void encryptSonnet() throws IOException {
        Files.write(Paths.get(cryptSonnet), encryptFile(sonnet).getBytes());
    }

    public String decryptSonnet() {
        return decryptFile(cryptSonnet);
    }

    public String encryptFile(String filePath) {
        try {
            return encrypt(parseFile(filePath));
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        return null;
    }

    public String decryptFile(String encryptedFilePath) {
        try {
            return decrypt(parseFile(encryptedFilePath));
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        return null;
    }

    public String parseFile(String filePath) throws IOException {
        List<String> content = Files.readAllLines(Paths.get(filePath));
        StringBuilder result = new StringBuilder();
        content.forEach(e -> result.append(e).append("\n"));
        return result.toString();
    }
}
